Package: groovy.org.codenarc.rule.formatting

## [Groovy] Class ClassJavadocRule

- groovy.org.codenarc.rule.formatting.ClassJavadocRule

- Makes sure each class and interface definition is preceded by javadoc. Enum definitions are not checked, due to strange behavior in the Groovy AST.

  Authors:
    Hamlet D'Arcy
    Geli Crick

- - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `boolean` | `applyToNonMainClasses`
    `String` | `name`
    `int` | `priority`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `void` | `applyTo(SourceCode sourceCode, List violations)` Apply the rule to the given source, writing violations to the given list.
    `` | `protected String` | `sourceCodeNameWithoutExtension(SourceCode sourceCode)`

- - ### Property Detail

    - #### boolean applyToNonMainClasses

    - #### String name

    - #### int priority

  - ### Method Detail

    - #### @Override @SuppressWarnings('EmptyWhileStatement') void applyTo(SourceCode sourceCode, List violations)

      Apply the rule to the given source, writing violations to the given list.

      Parameters:
        `sourceCode` - The source to check
        `violations` - A list of Violations that may be added to. It can be an empty list

    - #### protected String sourceCodeNameWithoutExtension(SourceCode sourceCode)